package prototype.database.postgresql;

/**
 * Class representing the database configuration.
 * 
 * 
 *
 */
public class PostgreSqlConfiguration {

	/**
	 * The url pointing to the database (without "jdbc:mysql://")
	 */
	private String url;
	/**
	 * The username.
	 */
	private String user;
	/**
	 * The password.
	 */
	private String password;

	/**
	 * Constructor.
	 * 
	 * @param url
	 *            - The url
	 * @param user
	 *            - The user
	 * @param password
	 *            - The password
	 * @throws Exception
	 */
	public PostgreSqlConfiguration(String url, String user, String password) throws Exception {
		if (url != null)
			if (user != null && !user.isEmpty())
				if (password != null) {
					if(url.startsWith("jdbc:postgresql://"))
					{
						url = url.replace("jdbc:postgresql://", "");
					}
					this.url = url;
					this.user = user;
					this.password = password;
				} else
					throw new Exception("Password cannot be null.");
			else
				throw new Exception("User cannot be null or empty.");
		else
			throw new Exception("Url cannot be null.");
	}

	/**
	 * Get the connection string associated with the configuration.
	 * 
	 * @return The connection string.
	 */
	public String getConnectionString() {
//		return "jdbc:postgresql://" + url + "?user=" + user + "&password=" + password+"&allowMultiQueries=true";

		return "jdbc:postgresql://" + url + "?user=" + user + "&password=" + password+"&allowMultiQueries=true";
	}

}
