package prototype.objects;

import java.util.List;
import java.util.Set;

import prototype.interfaces.CopyException;
import prototype.objects.constraints.IConstraint;
import prototype.queries.domain.relational.calculus.syntax.expressions.Variable;

/**
 * Interface representing relation schemas.
 * 
 * 
 *
 */
public interface ITable extends IDbObject, IType {

	/**
	 * Get the integrity constraints defined over the table.
	 * 
	 * @return The set of all integrity constraints.
	 */
	public Set<IConstraint> getConstraints();

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.objects.IDbObject#copy()
	 */
	public ITable copy() throws CopyException;

	/**
	 * Returns the list of free variables with the same name as the table's fields.
	 * 
	 * @return The list of variables.
	 */
	public List<Variable> getFreeVariables();
}
