package prototype.objects;

import java.util.List;

/**
 * Interface for objects that can be used as types.
 * 
 * 
 *
 */
public interface IType  {
	
	
	/**
	 * Get the type's unique identifier.
	 * 
	 * @return The type's Id.
	 */
	public String getId();
	

	/**
	 * Get the type's fields.
	 * 
	 * @return the type's fields.
	 */
	public List<String> getFields();

	/**
	 * Get the type's cardinality.
	 * 
	 * @return The type's cardinality.
	 */
	public int getCardinality();
	

	
}
