package prototype.objects;

import prototype.interfaces.CopyException;
import prototype.statements.interfaces.select.ISelectStatement;

/**
 * Interface representing Views.
 * 
 * 
 *
 */
public interface IView extends IDbObject, IType {

	/**
	 * Get the query defining the view.
	 * 
	 * @return The query defining the view.
	 */
	public ISelectStatement getSelectQuery();
	

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.objects.IDbObject#copy()
	 */
	public IView copy() throws CopyException;
}
