package prototype.objects.implementation;

import java.util.List;
import java.util.Vector;

import prototype.objects.IType;
import prototype.objects.MalformedDbObjectException;

/**
 * Class for basic types.
 * 
 * 
 *
 */
public class BasicType implements IType {

	/**
	 * The type's id.
	 */
	private String id;

	private List<String> fields;

	/**
	 * Constructor.
	 * 
	 * @param id
	 *            - The type's id.
	 * @param fields
	 *            - The type's fields.
	 * @throws MalformedDbObjectException
	 */
	public BasicType(String id, List<String> fields) throws MalformedDbObjectException {
		if (id != null && !id.isEmpty())
			if (fields != null ) {

				for (int i = 0; i < fields.size(); i++)
					for (int j = 0; j < fields.size(); j++)
						if (i != j && fields.get(i).equals(fields.get(j)))
							throw new MalformedDbObjectException("The list of fields contains duplicates.");

				this.id = id;
				this.fields = new Vector<String>(fields);
			} else
				throw new MalformedDbObjectException("Fields cannot be null or empty.");
		else
			throw new MalformedDbObjectException("Id cannot be null or empty.");
	}

	@Override
	public String getId() {
		return this.id;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.objects.IType#getFields()
	 */
	@Override
	public List<String> getFields() {
		return this.fields;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.objects.IType#getCardinality()
	 */
	@Override
	public int getCardinality() {
		return fields.size();
	}


}
