package prototype.objects.implementation.triggers.events;

import prototype.interfaces.CopyException;
import prototype.interfaces.ICopiable;
import prototype.objects.ITable;

/**
 * Interface representing trigger events, e.g., AFTER INSERT ON table.
 * 
 * 
 *
 */
public interface ITriggerEvent extends ICopiable{

	/**
	 * Get the TIME, i.e., either AFTER or BEFORE.
	 * 
	 * @return Either AFTER or BEFORE.
	 */
	public TIME getTime();

	/**
	 * Get the event, i.e., either INSERT or DELETE.
	 * 
	 * @return The event.
	 */
	public EVENT getEvent();

	/**
	 * Get the table associated with the event.
	 * 
	 * @return The table.
	 */
	public ITable getRelationSchema();
	
	
	/* (non-Javadoc)
	 * @see guarnieri.marco.ethz.interfaces.ICopiable#copy()
	 */
	public ITriggerEvent copy() throws CopyException;
	
	
	
	public String getDefinition();
	

}
