package prototype.pdp;

import prototype.statements.interfaces.IStatement;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IState;

/**
 * Interface representing the access control mechanism.
 * 
 * 
 *
 */
public interface IAccessControlMechanism {

	/**
	 * The method takes as input a state and a system state and returns True if the statement is authorized, false otherwise.
	 * 
	 * @param statement
	 *            - The statement.
	 * @param systemState
	 *            - The state.
	 * @return The access control decision.
	 */
	public boolean authorizes(IStatement statement, IState systemState) throws ExecutionException;

}
