package prototype.privileges;

import prototype.interfaces.CopyException;

/**
 * Class representing the CREATE VIEW privilege.
 * 
 * 
 *
 */
public class CreateViewPrivilege implements IPrivilege {

	/**
	 * The singleton instance.
	 */
	private static CreateViewPrivilege singleton_;

	/**
	 * Get the instance.
	 * 
	 * @return The instance.
	 */
	public static CreateViewPrivilege getInstance() {
		if (singleton_ == null)
			singleton_ = new CreateViewPrivilege();
		return singleton_;
	}

	/**
	 * Private Constructor.
	 */
	private CreateViewPrivilege() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof CreateViewPrivilege) {
			return true;
		} else
			return false;

	}


	@Override
	public String toSql() {
		return PRIVILEGE.CREATE_VIEW.toString();
	}

	@Override
	public IPrivilege copy() throws CopyException {
		return getInstance();
	}
	
	@Override
	public int hashCode() {
		int result = 17;
		result = 31 * result + PRIVILEGE.CREATE_VIEW.hashCode();
		return result;
	}
	
	@Override
	public String toString() {
		return toSql();
	}

}
