package prototype.queries.domain.relational.calculus;

import java.util.List;

import prototype.interfaces.CopyException;
import prototype.queries.domain.relational.calculus.syntax.expressions.Variable;

/**
 * Interface representing the domain relational calculus non-boolean queries.
 * 
 * 
 *
 */
public interface INonBooleanQuery extends IQuery {
	
	/**
	 * Get the output variables.
	 * 
	 * @return The output variables.
	 */
	public List<Variable> getOutput();

	public INonBooleanQuery copy() throws CopyException;
}
