package prototype.queries.domain.relational.calculus;

import prototype.interfaces.CopyException;
import prototype.interfaces.ICopiable;
import prototype.queries.domain.relational.calculus.syntax.IExpression;

/**
 * Interface representing the domain relational calculus queries.
 * 
 * 
 *
 */
public interface IQuery extends ICopiable {

	/**
	 * Get the expression associated with the query.
	 * 
	 * @return The expression.
	 */
	public IExpression getExpression();
	
	
	public IQuery copy() throws CopyException;
}
