package prototype.queries.domain.relational.calculus.syntax.expressions;

import prototype.queries.domain.relational.calculus.syntax.IExpression;
import prototype.queries.domain.relational.calculus.visitors.IVisitor;

public class FalseExpression implements IExpression {

	
	private static FalseExpression singleton_;

	private FalseExpression() {
	}
	
	public static FalseExpression getInstance()
	{
		if(singleton_ == null)
			singleton_ = new FalseExpression();
		
		return singleton_;
	}
 
	
	@Override
	public void accept(IVisitor visitor) {
		visitor.visit(this);
	}

	@Override
	public IExpression copy() {
		return this;
	}
	
	@Override
	public String toString() {
		return "FALSE";
	}

}
