package prototype.queries.domain.relational.calculus.syntax.expressions;

import prototype.queries.domain.relational.calculus.syntax.IExpression;
import prototype.queries.domain.relational.calculus.visitors.IVisitor;

public class TrueExpression implements IExpression {

	
	private static TrueExpression singleton_;

	private TrueExpression() {
	}
	
	public static TrueExpression getInstance()
	{
		if(singleton_ == null)
			singleton_ = new TrueExpression();
		
		return singleton_;
	}
 
	
	@Override
	public void accept(IVisitor visitor) {
		visitor.visit(this);
	}

	@Override
	public IExpression copy()  {
		return this;
	}
	
	@Override
	public String toString() {
		return "TRUE";
	}

}
