package prototype.queries.operators;

import prototype.queries.MalformedExpressionException;
import prototype.queries.domain.relational.calculus.visitors.IVisitor;

/**
 * Singleton class for the = operator.
 * 
 * 
 *
 */
public class Equality extends Operator {

	/** The unique instance of the singleton. */
	private static Equality singleton_ = null;

	/**
	 * Get the singleton instance of the operator.
	 * 
	 * @return The operator.
	 * @throws MalformedExpressionException
	 */
	public static Equality getInstance() throws MalformedExpressionException {
		if (singleton_ == null) {
			singleton_ = new Equality("=", 2, 2);
		}
		return singleton_;
	}

	/**
	 * Private Constructor.
	 * 
	 * @param name
	 *            - Operator's name.
	 * @param maxArity
	 *            - Operator's maximum arity.
	 * @param minArity
	 *            - Operator's minimum arity.
	 */
	private  Equality(String name, int maxArity, int minArity) throws MalformedExpressionException {
		super(name, maxArity, minArity);
	}

	/* (non-Javadoc)
	 * @see guarnieri.marco.ethz.queries.visitor.IVisitable#accept(guarnieri.marco.ethz.queries.visitor.IVisitor)
	 */
	@Override
	public void accept(IVisitor visitor) {
		visitor.visit(this);		
	}
}
