package prototype.results.accessControlResult;

import prototype.results.explanation.ISecurityExplanation;

/**
 * Interface for single access control results.
 * 
 * 
 *
 */
public interface IActionAccessControlResult extends IAccessControlResult{

	/**
	 * Get the access control decision.
	 * 
	 * @return True if the access control mechanism authorized the action. False otherwise.
	 */
	public boolean getResult();

	/**
	 * Get the detailed explanation for the security exception.
	 * 
	 * @return The explanation if the statement has caused a security exception. Null otherwise.
	 */
	public ISecurityExplanation getExplanation();
}
