package prototype.results.accessControlResult;

import prototype.results.explanation.ISecurityExplanation;

/**
 * Interface for single access control results.
 * 
 * 
 *
 */
public interface ITriggerAccessControlResult extends IAccessControlResult{

	/**
	 * Get the access control decision for the trigger's condition.
	 * 
	 * @return True if the access control mechanism authorized the action. False otherwise.
	 */
	public boolean getTriggerConditionResult();

	/**
	 * Get the detailed explanation for the security exception.
	 * 
	 * @return The explanation if the statement has caused a security exception. Null otherwise.
	 */
	public ISecurityExplanation getTriggerConditionExplanation();
	
	
	/**
	 * Get the access control decision for the trigger's action.
	 * 
	 * @return True if the access control mechanism authorized the action. False otherwise.
	 */
	public boolean getTriggerActionResult();

	/**
	 * Get the detailed explanation for the security exception.
	 * 
	 * @return The explanation if the statement has caused a security exception. Null otherwise.
	 */
	public ISecurityExplanation getTriggerActionExplanation();
}
