package prototype.results.actionResults;

import prototype.results.explanation.IIntegrityExplanation;

/**
 * Interface for all action's results.
 * 
 * 
 *
 */
public interface ISingleActionResult extends IActionResult{

	
	/**
	 * Get the exception's status. Note that this method does not give any information about security exceptions.
	 * 
	 * @return True if the action's execution has caused an exception. False otherwise.
	 */
	public boolean exception();
	
	/**
	 * Get the explanation associated with the exception.
	 * 
	 * @return The explanation if the statement has caused an exception. Null otherwise.
	 * 
	 */
	public IIntegrityExplanation getExceptionExplanation();

}
