package prototype.results.actionResults;

import prototype.results.explanation.IIntegrityExplanation;

/**
 * Interface for all action's results.
 * 
 * 
 *
 */
public interface ITriggerResult extends IActionResult {

	/**
	 * Get the result of the trigger's condition.
	 * 
	 * @return The result of trigger's condition.
	 */
	public boolean getConditionResult();
	
	/**
	 * Get the result of the trigger's action.
	 * 
	 * @return The result of trigger's action.
	 */
	public boolean getActionResult();

	/**
	 * Get the exception's status. Note that this method does not give any information about security exceptions.
	 * 
	 * @return True if the trigger action's execution has caused an exception. False otherwise.
	 */
	public boolean getActionException();

	/**
	 * Get the explanation associated with the exception.
	 * 
	 * @return The explanation if the statement has caused an exception. Null otherwise.
	 * 
	 */
	public IIntegrityExplanation getExceptionExplanation();

}
