package prototype.results.implementation;

import prototype.results.accessControlResult.IActionAccessControlResult;
import prototype.results.explanation.ISecurityExplanation;

/**
 * Class representing access control results.
 * 
 * 
 *
 */
public class ActionAccessControlResult implements IActionAccessControlResult {

	/**
	 * Explanation
	 */
	private ISecurityExplanation explanation;
	/**
	 * The access control result.
	 */
	private boolean result;

	/**
	 * Constructor.
	 * 
	 * @param result
	 *            - The access control result.
	 * @param explanation
	 *            - The explanation.
	 * @throws MalformedResultException
	 */
	public ActionAccessControlResult(boolean result, ISecurityExplanation explanation) throws MalformedResultException {
		if ((result == true && explanation == null) || (result == false && explanation != null)) {
			this.result = result;
			this.explanation = explanation;
		} else
			throw new MalformedResultException("Result is true and explanation is not null OR result is false and explanation is null.");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.results.accessControlResult.IActionAccessControlResult#getResult()
	 */
	@Override
	public boolean getResult() {
		return this.result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.results.accessControlResult.IActionAccessControlResult#getExplanation()
	 */
	@Override
	public ISecurityExplanation getExplanation() {
		return this.explanation;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		if (result)
			return "Acc.Ctrl.: " + result;
		else
			return "Acc.Ctrl.: " + result + " Cause: " + explanation;
	}
	
	


}
