package prototype.statements.abstractImplementation.changePolicy;

import prototype.privileges.IPrivilege;
import prototype.results.actionResults.IActionResult;
import prototype.statements.MalformedStatementException;
import prototype.statements.interfaces.changePolicy.IGrantStatement;
import prototype.statements.modes.CHANGE_POLICY_MODE;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IDatabaseEngine;
import prototype.system.interfaces.IState;
import prototype.users.IUser;
import prototype.util.Pair;

/**
 * Abstract class representing GRANT statements.
 * 
 * 
 *
 */
public abstract class GrantStatement extends ChangePolicyStatement implements IGrantStatement {

	public GrantStatement(IUser invoker, CHANGE_POLICY_MODE mode, IPrivilege privilege, IUser target) throws MalformedStatementException {
		super(invoker, mode, privilege, target);
		if (mode != CHANGE_POLICY_MODE.GRANT)
			throw new MalformedStatementException("Mode must be GRANT.");
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.interfaces.IExecutable#execute(guarnieri.marco.ethz.system.interfaces.IExecutionEngine,
	 * guarnieri.marco.ethz.system.interfaces.IState)
	 */
	@Override
	public Pair<IActionResult,IState> execute(IDatabaseEngine engine, IState state)  throws ExecutionException{
		return engine.execute(this, state);
	}

}
