package prototype.statements.abstractImplementation.create;

import prototype.objects.ITable;
import prototype.results.actionResults.IActionResult;
import prototype.statements.MalformedStatementException;
import prototype.statements.interfaces.create.ICreateTableStatement;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IDatabaseEngine;
import prototype.system.interfaces.IState;
import prototype.users.IUser;
import prototype.util.Pair;

/**
 * Abstract class representing CREATE TABLE statements.
 * 
 * 
 */
public abstract class CreateTableStatement extends CreateStatement implements ICreateTableStatement{

	public CreateTableStatement(IUser invoker, ITable object) throws MalformedStatementException {
		super(invoker, object);
	}
	
	@Override
	public ITable getObject() {
		return (ITable) super.getObject();
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.interfaces.IExecutable#execute(guarnieri.marco.ethz.system.interfaces.IExecutionEngine,
	 * guarnieri.marco.ethz.system.interfaces.IState)
	 */
	@Override
	public Pair<IActionResult,IState> execute(IDatabaseEngine engine, IState state)  throws ExecutionException{
		return engine.execute(this, state);
	}
}
