package prototype.statements.abstractImplementation.create;

import prototype.objects.ITrigger;
import prototype.results.actionResults.IActionResult;
import prototype.statements.MalformedStatementException;
import prototype.statements.interfaces.create.ICreateTriggerStatement;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IDatabaseEngine;
import prototype.system.interfaces.IState;
import prototype.users.IUser;
import prototype.util.Pair;

/**
 * Abstract class representing CREATE TRIGGER statements.
 * 
 * 
 */
public abstract class CreateTriggerStatement extends CreateStatement implements ICreateTriggerStatement {

	public CreateTriggerStatement(IUser invoker, ITrigger object) throws MalformedStatementException {
		super(invoker, object);
	}
	
	@Override
	public ITrigger getObject() {
		return (ITrigger) super.getObject();
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.interfaces.IExecutable#execute(guarnieri.marco.ethz.system.interfaces.IExecutionEngine,
	 * guarnieri.marco.ethz.system.interfaces.IState)
	 */
	@Override
	public Pair<IActionResult,IState> execute(IDatabaseEngine engine, IState state) throws ExecutionException {
		return engine.execute(this, state);
	}
}
