package prototype.statements.abstractImplementation.create;

import prototype.objects.IView;
import prototype.results.actionResults.IActionResult;
import prototype.statements.MalformedStatementException;
import prototype.statements.interfaces.create.ICreateViewStatement;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IDatabaseEngine;
import prototype.system.interfaces.IState;
import prototype.users.IUser;
import prototype.util.Pair;

/**
 * Abstract class representing CREATE TABLE statements.
 * 
 * 
 */
public abstract class CreateViewStatement extends CreateStatement implements ICreateViewStatement {

	public CreateViewStatement(IUser invoker, IView object) throws MalformedStatementException {
		super(invoker, object);
	}
	
	@Override
	public IView getObject() {
		return (IView) super.getObject();
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.interfaces.IExecutable#execute(guarnieri.marco.ethz.system.interfaces.IExecutionEngine,
	 * guarnieri.marco.ethz.system.interfaces.IState)
	 */
	@Override
	public Pair<IActionResult,IState> execute(IDatabaseEngine engine, IState state)  throws ExecutionException{
		return engine.execute(this, state);
	}
	
	
}
