package prototype.statements.abstractImplementation.update;

import prototype.objects.ITable;
import prototype.results.actionResults.IActionResult;
import prototype.statements.MalformedStatementException;
import prototype.statements.interfaces.update.IInsertStatement;
import prototype.statements.modes.UPDATE_MODE;
import prototype.system.implementation.ExecutionException;
import prototype.system.interfaces.IDatabaseEngine;
import prototype.system.interfaces.IState;
import prototype.tuple.ITuple;
import prototype.users.IUser;
import prototype.util.Pair;

/**
 * Abstract class representing INSERT statements.
 * 
 * 
 *
 */
public abstract class InsertStatement extends UpdateStatement implements IInsertStatement {

	public InsertStatement(IUser invoker, UPDATE_MODE mode, ITable schema, ITuple tuple) throws MalformedStatementException {
		super(invoker, mode, schema, tuple);
		if (mode != UPDATE_MODE.INSERT)
			throw new MalformedStatementException("Mode must be update.");
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.interfaces.IExecutable#execute(guarnieri.marco.ethz.system.interfaces.IExecutionEngine,
	 * guarnieri.marco.ethz.system.interfaces.IState)
	 */
	@Override
	public Pair<IActionResult,IState> execute(IDatabaseEngine engine, IState state) throws ExecutionException {
		return engine.execute(this, state);
	}

}
