package prototype.statements.implementation.mysql.create;

import prototype.interfaces.CopyException;
import prototype.objects.ITrigger;
import prototype.statements.MalformedStatementException;
import prototype.statements.abstractImplementation.create.CreateTriggerStatement;
import prototype.statements.interfaces.TranslationException;
import prototype.statements.interfaces.create.ICreateTriggerStatement;
import prototype.users.IUser;

/**
 * The concrete class representing CREATE TRIGGER statements for the MySql database.
 * 
 * 
 *
 */
public class MySqlCreateTriggerStatement extends CreateTriggerStatement {

	/**
	 * Constructor.
	 * 
	 * @param invoker
	 *            - The user executing the command.
	 * @param object
	 *            - The trigger to be created.
	 * @throws MalformedStatementException
	 */
	public MySqlCreateTriggerStatement(IUser invoker, ITrigger object) throws MalformedStatementException {
		super(invoker, object);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see guarnieri.marco.ethz.statements.implementation.abstraction.create.CreateStatement#toSQL()
	 */
	@Override
	public String toSQL() throws TranslationException {
		assert(false);
		return null;
//		String cmd = "DELIMITER $$ CREATE TRIGGER " + this.getObject().getId() + " AFTER " + ((ITrigger) this.getObject()).getEvent().toSQL()
//				+ " FOR EACH ROW " + " IF (" + ((ITrigger) this.getObject()).getCondition().toSQL() + ") THEN "
//				+ ((ITrigger) this.getObject()).getAction().toSQL() + " END IF; END; $$ " + " DELIMITER ; ";
//		return cmd;

	}

	@Override
	public ICreateTriggerStatement copy() throws CopyException {
		try {
			return new MySqlCreateTriggerStatement(getInvoker(), this.getObject().copy());
		} catch (MalformedStatementException e) {
			throw new CopyException(e);
		}
	}
}
