package prototype.statements.interfaces.create;

import prototype.interfaces.CopyException;
import prototype.objects.IDbObject;
import prototype.statements.interfaces.IStatement;
import prototype.statements.modes.CREATE_MODE;

/**
 * Interface for the CREATE TRIGGER and CREATE VIEW commands.
 * 
 * 
 *
 */
public interface ICreateStatement  extends IStatement{

	/**
	 * The object used in the statement.
	 * 
	 * @return The object in the statement.
	 */
	public IDbObject getObject();
	
	
	/**
	 * Get the update mode.
	 * 
	 * @return The update mode.
	 */
	public CREATE_MODE getMode();
	
	public ICreateStatement copy()  throws CopyException;
}
