package prototype.statements.interfaces.update;

import prototype.interfaces.CopyException;
import prototype.objects.ITable;
import prototype.statements.interfaces.IStatement;
import prototype.statements.modes.UPDATE_MODE;
import prototype.tuple.ITuple;

/**
 * Interface for INSERT and DELETE statements.
 * 
 * 
 *
 */
public interface IUpdateStatement extends IStatement {

	/**
	 * Get the relation schema used in the statement.
	 * 
	 * @return the relation schema.
	 */
	public ITable getRelationSchema();

	/**
	 * Get the tuple added by the statement.
	 * 
	 * @return the tuple added by the statement.
	 */
	public ITuple getTuple();

	/**
	 * Get the update mode.
	 * 
	 * @return The update mode.
	 */
	public UPDATE_MODE getMode();
	
	public IUpdateStatement copy()  throws CopyException;
}
