package prototype.tuple;

import java.util.List;

import prototype.interfaces.CopyException;
import prototype.interfaces.ICopiable;
import prototype.queries.domain.relational.calculus.syntax.IOperand;

/**
 * Interface for tuples.
 * 
 * 
 *
 */
public interface ITuple extends ICopiable{
	
	/**
	 * Get the tuple's size.
	 * 
	 * @return The integer representing the tuple's size.
	 */
	public int getSize();

	/**
	 * Get the tuple's content.
	 * 
	 * @return The tuple's content.
	 */
	public List<IOperand> getContent();
	
	public ITuple copy() throws CopyException;

}
