package prototype.users;

/**
 * Factory for the user class.
 * 
 * 
 *
 */
public interface IUserFactory {

	/**
	 * Create a new user.
	 * 
	 * @param id
	 *            - userID
	 * @return the new user.
	 * @throws MalformedUserException
	 */
	public IUser createUser(String id) throws MalformedUserException;

	/**
	 * Get the user representing the administrator.
	 * 
	 * @return The admin.
	 * @throws MalformedUserException 
	 */
	public IUser getAdmin() throws MalformedUserException;

}
