package prototype.users;

import prototype.interfaces.CopyException;

/**
 * CLass implementing users.
 * 
 * 
 *
 */
public class User implements IUser {

	/**
	 * Username.
	 */
	private String username;

	public User(String username) throws MalformedUserException {
		if (username != null && !username.isEmpty())
			this.username = username;
		else
			throw new MalformedUserException("Username cannot be null or empty.");
	}

	@Override
	public String getUsername() {
		return username;
	}

	@Override
	public IUser copy() throws CopyException {
		try {
			return new User(getUsername());
		} catch (MalformedUserException e) {
			throw new CopyException(e);
		}
	}

	@Override
	public String toString() {
		return username;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof User) {
			return ((User) obj).username.equals(username);
		} else
			return false;
	}

	@Override
	public int hashCode() {
		int result = 17;
		result = 31 * result + username.hashCode();
		return result;
	}
}
