package prototype.users;

/**
 * User factory.
 * 
 * 
 *
 */
public class UserFactory implements IUserFactory {

	/**
	 * Singleton instance.
	 */
	private static UserFactory singleton_;

	/**
	 * The admin's identifier.
	 */
	private static String adminId = "admin";

	/**
	 * Private constructor.
	 */
	private UserFactory() {

	}

	/**
	 * Get the singleton's instance.
	 * 
	 * @return The instance.
	 */
	public static UserFactory getInstance() {
		if (singleton_ == null)
			singleton_ = new UserFactory();
		return singleton_;
	}

	@Override
	public IUser createUser(String id) throws MalformedUserException {
		return new User(id);
	}

	@Override
	public IUser getAdmin() throws MalformedUserException {
			return new User(adminId);
	}

}
